from dataclasses import dataclass

from ..result import Result
from ..transformer import Transformer
from .map import MapTransform


@dataclass
class JoinTransform(Transformer[str]):
    items: Transformer[list[str]]
    join: str

    def __init__(self, items: Transformer[list[str]], join: str) -> None:
        self.items = items
        self.join = ""
        self.actual = MapTransform(items, lambda l: join.join(l))

    def parse(self, stream: str, at_index: int) -> Result[str]:
        return self.actual.parse(stream, at_index)


from okipy.lib import test

# TOTEST
